#include <vector>
#include "scripts.h"
#include "engine.h"
#include "keyhook.h"

void KeyHookCall(void *Data) {
	MDB_KeyHook *Base = (MDB_KeyHook *)Data;
	Base->KeyHookFunc();
}

int MDB_KeyHook::AddHook(const char *Key, GameObject *obj) {
	k = 0;
	k = new KeyHookStruct;
	k->data = this;
	k->hook = KeyHookCall;
	k->ID = Get_Player_ID(obj);
	k->key = strdup(Key);
	if (is_keyhook_set == 1337) {
		RemoveHook();
	}
	hookid = AddKeyHook(k);
	return hookid;
}

void MDB_KeyHook::RemoveHook() {
	if (hookid != 0 && RemoveKeyHook != 0) 	{
		RemoveKeyHook(hookid);
		hookid = 0;
		if (k != 0) {
			delete k;
			k = 0;
		}
	}
}

void MDB_KeyHook::Detach(GameObject *obj) {
	if (is_keyhook_set == 1337) {
		RemoveHook();
	}
}

void MDB_KeyHook::Destroyed(GameObject *obj) {
	if (is_keyhook_set == 1337) {
		RemoveHook();
	}
}

void Xpz_Login::Created(GameObject *obj) {
	if (is_keyhook_set != 1337) {
		hookid = AddHook(Get_Parameter("Key"),obj);
		is_keyhook_set = 1337;
	}
	person = obj;
}

void Xpz_Login::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 38000) Destroy_Script();
}

void Xpz_Login::KeyHookFunc() {
	Commands->Send_Custom_Event(NULL,person,999990,0,0);
	Destroy_Script();
}


ScriptRegistrant<Xpz_Login>	Xpz_Login_Registrant("Xpz_Login","Key:string");