-- phpMyAdmin SQL Dump
-- version 2.8.0.2
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: May 13, 2006 at 05:26 AM
-- Server version: 4.1.18
-- PHP Version: 4.4.2
-- 
-- Database: `xpzelite`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `Server_Settings`
-- 

CREATE TABLE `Server_Settings` (
  `prefex` text NOT NULL,
  `title` text NOT NULL,
  `max_players` int(11) NOT NULL default '24',
  `credits` int(11) NOT NULL default '0',
  `time_limit` int(11) NOT NULL default '30',
  `radar` int(11) NOT NULL default '1',
  `ladder` int(11) NOT NULL default '1',
  `spawn_weapon` int(11) NOT NULL default '1',
  `password` text NOT NULL,
  `team_change` int(11) NOT NULL default '0',
  `friend_fire` int(11) NOT NULL default '0',
  `remix` int(11) NOT NULL default '1',
  `end_base` int(11) NOT NULL default '1',
  `end_beacon` int(11) NOT NULL default '0',
  `maplist` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `Server_Settings`
-- 

INSERT INTO `Server_Settings` VALUES ('bob', 'XpHaZe Marathon', 24, 0, 30, 1, 1, 1, '', 0, 0, 1, 1, 0, 'C&C_Field.mix\r\nC&C_Canyon.mix\r\nC&C_City_Flying.mix\r\nC&C_Islands.mix');

-- --------------------------------------------------------

-- 
-- Table structure for table `ladder`
-- 

CREATE TABLE `ladder` (
  `name` text NOT NULL,							-- 0
  `score` BIGINT UNSIGNED DEFAULT '0' NOT NULL,	-- 1
  `kills` int(11) NOT NULL default '0',			-- 2
  `deaths` int(11) NOT NULL default '0',		-- 3
  `kd` float NOT NULL default '0',				-- 4
  `games` BIGINT UNSIGNED NOT NULL default '0',	-- 5
  `snipe_honor` int(11) NOT NULL default '0',	-- 6
  `tank_honor` int(11) NOT NULL default '0',	-- 7
  `exp` BIGINT UNSIGNED DEFAULT '0' NOT NULL,	-- 8
  `honor` int(11) NOT NULL default '0'			-- 9
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `ladder`
-- 

INSERT INTO `ladder` VALUES ('andysh', 12314, 50, 25, 2, 5, 3, 4, 0, 0);

-- --------------------------------------------------------

-- 
-- Table structure for table `prefex_building`
-- 

CREATE TABLE `prefex_building` (
  `id` int(11) NOT NULL default '0',
  `name` text NOT NULL,
  `side` int(11) NOT NULL default '0',
  `max_hp` int(11) NOT NULL default '0',
  `max_sp` int(11) NOT NULL default '0',
  `now_hp` int(11) NOT NULL default '0',
  `now_sp` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `prefex_building`
-- 

INSERT INTO `prefex_building` VALUES (0, 'Barracks', 1, 500, 500, 500, 400);

-- --------------------------------------------------------

-- 
-- Table structure for table `prefex_players`
-- 

CREATE TABLE `prefex_players` (
  `id` int(11) NOT NULL default '0',
  `name` text NOT NULL,
  `max_hp` int(11) NOT NULL default '0',
  `max_sp` int(11) NOT NULL default '0',
  `now_hp` int(11) NOT NULL default '0',
  `now_sp` int(11) NOT NULL default '0',
  `credit` int(11) NOT NULL default '0',
  `score` int(11) NOT NULL default '0',
  `kills` int(11) NOT NULL default '0',
  `deaths` int(11) NOT NULL default '0',
  `preset` text NOT NULL,
  `side` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `prefex_players`
-- 

INSERT INTO `prefex_players` VALUES (1, 'andysh', 100, 100, 100, 95, 1530, 200, 5, 2);

-- --------------------------------------------------------

-- 
-- Table structure for table `servers`
-- 

CREATE TABLE `servers` (
  `name` text NOT NULL,
  `username` text NOT NULL,
  `map` text NOT NULL,
  `gdi` int(11) NOT NULL default '0',
  `nod` int(11) NOT NULL default '0',
  `gdi_point` int(11) NOT NULL default '0',
  `nod_point` int(11) NOT NULL default '0',
  `max_players` int(11) NOT NULL default '0',
  `irc` int(11) NOT NULL default '0',
  `renguard` int(11) NOT NULL default '0',
  `teamspeak` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `online` int(11) NOT NULL default '0',
  `interval` int(11) NOT NULL default '0',
  `ip` text NOT NULL,
  `prefex` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `servers`
-- 

INSERT INTO `servers` VALUES ('XpHaZe Marathon', 'a0000021', 'C&C_Field.mix', 6, 5, 1250, 3000, 24, 1, 1, 0, 21, 1, 2, '251.168.235.42', 'bob');

-- --------------------------------------------------------

-- 
-- Table structure for table `bans`
-- 

CREATE TABLE `bans` (
  `name` text NOT NULL,
  `type` int(11) NOT NULL default '0',
  `ip` text NOT NULL,
  `serial` text NOT NULL,
  `time` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `bans`
-- 

INSERT INTO `bans` VALUES ('andysh', 1, '215.146.235.2', '1337', 1147581832);

-- --------------------------------------------------------

-- 
-- Table structure for table `log`
-- 

CREATE TABLE `log` (
  `mod` text NOT NULL,
  `type` int(11) NOT NULL default '0',
  `name` text NOT NULL,
  `reason` text NOT NULL,
  `time` int(11) NOT NULL default '0',
  `ip` text NOT NULL,
  `serial` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `log`
-- 

INSERT INTO `log` VALUES ('andysh', 2, 'xiaorulez', 'got he is elite', 1147581832, '192.168.1.2', '1337');


-- --------------------------------------------------------

-- 
-- Table structure for table `mods`
-- 

CREATE TABLE `mods` (
  `user` text NOT NULL,
  `rank` int(11) NOT NULL default '0',
  `flags` text NOT NULL,
  `pass` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Dumping data for table `mods`
-- 

INSERT INTO `mods` VALUES ('bob', 2, 'abcdefghijklmnopqrstuvwxyz', '133769');

CREATE TABLE `maps` (
`map` TEXT NOT NULL ,
`prefex` TEXT NOT NULL ,
`crate_time` INT NOT NULL ,
`crate_var` INT NOT NULL ,
`bd_chance` INT NOT NULL
) TYPE = innodb;