CREATE TABLE `Server_Settings` (
  `prefex` text NOT NULL,
  `title` text NOT NULL,
  `max_players` int(11) NOT NULL default '24',
  `credits` int(11) NOT NULL default '0',
  `time_limit` int(11) NOT NULL default '30',
  `radar` int(11) NOT NULL default '1',
  `ladder` int(11) NOT NULL default '1',
  `spawn_weapon` int(11) NOT NULL default '1',
  `password` text NOT NULL,
  `team_change` int(11) NOT NULL default '0',
  `friend_fire` int(11) NOT NULL default '0',
  `remix` int(11) NOT NULL default '1',
  `end_base` int(11) NOT NULL default '1',
  `end_beacon` int(11) NOT NULL default '0',
  `maplist` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `ladder` (
  `name` text NOT NULL,
  `score` BIGINT UNSIGNED DEFAULT '0' NOT NULL,
  `kills` int(11) NOT NULL default '0',
  `deaths` int(11) NOT NULL default '0',
  `kd` float NOT NULL default '0',
  `games` BIGINT UNSIGNED NOT NULL default '0',
  `snipe_honor` int(11) NOT NULL default '0',
  `tank_honor` int(11) NOT NULL default '0',
  `exp` BIGINT UNSIGNED DEFAULT '0' NOT NULL,
  `honor` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `servers` (
  `name` text NOT NULL,
  `username` text NOT NULL,
  `map` text NOT NULL,
  `gdi` int(11) NOT NULL default '0',
  `nod` int(11) NOT NULL default '0',
  `gdi_point` int(11) NOT NULL default '0',
  `nod_point` int(11) NOT NULL default '0',
  `max_players` int(11) NOT NULL default '0',
  `irc` int(11) NOT NULL default '0',
  `renguard` int(11) NOT NULL default '0',
  `teamspeak` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `online` int(11) NOT NULL default '0',
  `interval` int(11) NOT NULL default '0',
  `ip` text NOT NULL,
  `prefex` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `bans` (
  `name` text NOT NULL,
  `type` int(11) NOT NULL default '0',
  `ip` text NOT NULL,
  `serial` text NOT NULL,
  `time` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `log` (
  `mod` text NOT NULL,
  `type` int(11) NOT NULL default '0',
  `name` text NOT NULL,
  `reason` text NOT NULL,
  `time` int(11) NOT NULL default '0',
  `ip` text NOT NULL,
  `serial` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `mods` (
  `user` text NOT NULL,
  `rank` int(11) NOT NULL default '0',
  `flags` text NOT NULL,
  `pass` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
