class Handler_Thread : public Thread {
private:
    int m_nCount;
	int speed;

public:
    Handler_Thread(int n,const char* nm) {
        Thread::setName(nm);
        m_nCount = n;
    }
    void run();
};

class MySQL_Thread : public Thread {
private:
    int m_nCount;
	int speed;

public:
    MySQL_Thread(int n,const char* nm) {
        Thread::setName(nm);
        m_nCount = n;
    }
    void run();
	bool connect(MYSQL *db, const char *ip, const char *user, const char *pass, const char *db_main, int port); // MySQL connecter
	void disconnect(MYSQL *db); // Disconnect from a MySQL database
};

class IRC_Thread : public Thread {
private:
    int m_nCount;
	int speed;

public:
	char chan[128];
	char chan2[128];
    IRC_Thread(int n,const char* nm) {
        Thread::setName(nm);
        m_nCount = n;
    }
    void run();
	void connect(SOCKET sock);
};

class Renguard_Thread : public Thread {
private:
    int m_nCount;
	int speed;

public:
    Renguard_Thread(int n,const char* nm) {
        Thread::setName(nm);
        m_nCount = n;
    }
    void run();
};

class TeamSpeak_Thread : public Thread {
private:
	int m_nCount;
	int speed;

public:
	TeamSpeak_Thread(int n,const char* nm) {
		Thread::setName(nm);
		m_nCount = n;
	}
	void run();
	void connect(SOCKET sock);
};

class XpzGuard_Thread : public Thread {
private:
	int m_nCount;
	int speed;

public:
	XpzGuard_Thread(int n,const char* nm) {
		Thread::setName(nm);
		m_nCount = n;
	}
	void run();
};

bool t_restart(Thread *tcurrent);